#ifndef LIBSARIA_FS_H
#define LIBSARIA_FS_H

#include <list>
#include <string>
using namespace std;

enum DataState {
	DIRTY,
	CLEAN,
};

namespace libsaria
{
	bool exists(string);
	void list_dir(string &, list<string> &);

	namespace app
	{

		void init(string);

		void list_dir(string &, list<string> &);
		unsigned int read_numdir(string &, void (*)(ifstream &));
		void mkdir(string);
		void mkdir();
		void rm(string);

		void save(string, void (*)(ofstream &, void *), DataState *, void *);
		void read(string, void (*)(ifstream &));
		void read_now(string, void (*)(ifstream &));

		void open_pipe();
		void close_pipe();
		string pipe_file();

	} /* Namespace: app */

} /* Namespace: libsaria */

#endif /* LIBSARIA_FS_H */
