#ifndef LIBSARIA_LIBRARY_H
#define LIBSARIA_LIBRARY_H

#include <fs.h>
#include <list.h>
#include <track.h>
#include <playlist.h>

#include <string>
using namespace std;

namespace libsaria
{

	namespace library
	{

		struct Path {
			bool visible;
			DataState data_state;
			unsigned int id;
			unsigned int next_track;
			string path;
			List<Track> tracks;
		};

		void init();
		void add_path(string);
		void delete_path(Path *);
		void update_path(Path *);
		void save_path(Path *);
		void update_all();

		void hide_path(Path *);
		void show_path(Path *);

		Track *lookup(unsigned int, unsigned int);
		void set_random(bool);
		Playlist *get_playlist();

	}
}

#endif /* LIBSARIA_LIBRARY_H */
