// Copyright (c) 2012 Bryan Schumaker.
#include <playlist.h>
#include <library.h>
#include <ban.h>

static libsaria::Playlist banned_plist(PL_STATIC | PL_NO_DRAIN | PL_RANDOM | PL_SORTED);

namespace libsaria
{

	Playlist *ban::get_banned_plist()
	{
		return &banned_plist;
	}

	void ban::track_banned(Track *track)
	{
		/* Remove from library playlist */
		library::get_playlist()->remove_track(track);

		/* Add to banned list */
		banned_plist.push_back(track);
	}

	void ban::track_unbanned(Track *track)
	{
		/* Remove from banned list */
		banned_plist.remove_track(track);

		/* Add to library playlist */
		library::get_playlist()->push_back(track);
	}

}
