// Copyright (c) 2012 Bryan Schumaker.
#include <task.h>

#include <fstream>
using namespace std;

WriteTask::WriteTask(string file, void (*fn)(ofstream &, void *),
		     DataState *s, void *d)
{
	filepath = file;
	func = fn;
	state = s;
	data = d;

	queue();
}

WriteTask::~WriteTask()
{
}

void WriteTask::run_task()
{
	if (*state == CLEAN)
		return;
	ofstream stream;
	stream.open(filepath.c_str());
	func(stream, data);
	stream.close();
}

bool WriteTask::should_cancel(void *d)
{
	return d == data;
}

ReadTask::ReadTask(string file, void (*fn)(ifstream &))
{
	filepath = file;
	func = fn;

	queue();
}

ReadTask::~ReadTask()
{
}

void ReadTask::run_task()
{
	ifstream stream;
	stream.open(filepath.c_str());
	func(stream);
	stream.close();
}
